"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.examples = void 0;
exports.getCachedPackagesDirs = getCachedPackagesDirs;
exports.hasWrapper = hasWrapper;
exports.run = void 0;
exports.setFlags = setFlags;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));

  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };

  return data;
}

function fs() {
  var data = _interopRequireWildcard(require("../../util/fs.js"));

  fs = function fs() {
    return data;
  };

  return data;
}

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var invariant = require('invariant');

var path = require('path');

var micromatch = require('micromatch');

function hasWrapper(flags, args) {
  return args[0] !== 'dir';
}

function getCachedPackagesDirs(_x, _x2) {
  return _getCachedPackagesDirs.apply(this, arguments);
}

function _getCachedPackagesDirs() {
  _getCachedPackagesDirs = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config, currentPath) {
    var results, stat, folders, _iterator, _step, folder, packageParentPath, candidates, _iterator2, _step2, candidate, candidatePath, subCandidates, _iterator3, _step3, subCandidate, subCandidatePath;

    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            results = [];
            _context2.next = 3;
            return fs().lstat(currentPath);

          case 3:
            stat = _context2.sent;

            if (stat.isDirectory()) {
              _context2.next = 6;
              break;
            }

            return _context2.abrupt("return", results);

          case 6:
            _context2.next = 8;
            return fs().readdir(currentPath);

          case 8:
            folders = _context2.sent;
            _iterator = _createForOfIteratorHelper(folders);
            _context2.prev = 10;

            _iterator.s();

          case 12:
            if ((_step = _iterator.n()).done) {
              _context2.next = 49;
              break;
            }

            folder = _step.value;

            if (!(folder[0] === '.')) {
              _context2.next = 16;
              break;
            }

            return _context2.abrupt("continue", 47);

          case 16:
            packageParentPath = path.join(currentPath, folder, 'node_modules');
            _context2.next = 19;
            return fs().readdir(packageParentPath);

          case 19:
            candidates = _context2.sent;
            invariant(candidates.length === 1, "There should only be one folder in a package cache (got ".concat(candidates.join(','), " in ").concat(packageParentPath, ")"));
            _iterator2 = _createForOfIteratorHelper(candidates);
            _context2.prev = 22;

            _iterator2.s();

          case 24:
            if ((_step2 = _iterator2.n()).done) {
              _context2.next = 39;
              break;
            }

            candidate = _step2.value;
            candidatePath = path.join(packageParentPath, candidate);

            if (!(candidate.charAt(0) === '@')) {
              _context2.next = 36;
              break;
            }

            _context2.next = 30;
            return fs().readdir(candidatePath);

          case 30:
            subCandidates = _context2.sent;
            invariant(subCandidates.length === 1, "There should only be one folder in a package cache (got ".concat(subCandidates.join(','), " in ").concat(candidatePath, ")"));
            _iterator3 = _createForOfIteratorHelper(subCandidates);

            try {
              for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                subCandidate = _step3.value;
                subCandidatePath = path.join(candidatePath, subCandidate);
                results.push(subCandidatePath);
              }
            } catch (err) {
              _iterator3.e(err);
            } finally {
              _iterator3.f();
            }

            _context2.next = 37;
            break;

          case 36:
            results.push(candidatePath);

          case 37:
            _context2.next = 24;
            break;

          case 39:
            _context2.next = 44;
            break;

          case 41:
            _context2.prev = 41;
            _context2.t0 = _context2["catch"](22);

            _iterator2.e(_context2.t0);

          case 44:
            _context2.prev = 44;

            _iterator2.f();

            return _context2.finish(44);

          case 47:
            _context2.next = 12;
            break;

          case 49:
            _context2.next = 54;
            break;

          case 51:
            _context2.prev = 51;
            _context2.t1 = _context2["catch"](10);

            _iterator.e(_context2.t1);

          case 54:
            _context2.prev = 54;

            _iterator.f();

            return _context2.finish(54);

          case 57:
            return _context2.abrupt("return", results);

          case 58:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[10, 51, 54, 57], [22, 41, 44, 47]]);
  }));
  return _getCachedPackagesDirs.apply(this, arguments);
}

function _getMetadataWithPath(getMetadataFn, paths) {
  return Promise.all(paths.map(function (path) {
    return getMetadataFn(path).then(function (r) {
      r._path = path;
      return r;
    })["catch"](function (error) {
      return undefined;
    });
  }));
}

function getCachedPackages(_x3) {
  return _getCachedPackages.apply(this, arguments);
}

function _getCachedPackages() {
  _getCachedPackages = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee3(config) {
    var paths;
    return _regenerator()["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return getCachedPackagesDirs(config, config.cacheFolder);

          case 2:
            paths = _context3.sent;
            return _context3.abrupt("return", _getMetadataWithPath(config.readPackageMetadata.bind(config), paths).then(function (packages) {
              return packages.filter(function (p) {
                return !!p;
              });
            }));

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getCachedPackages.apply(this, arguments);
}

function list(_x4, _x5, _x6, _x7) {
  return _list.apply(this, arguments);
}

function _list() {
  _list = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee4(config, reporter, flags, args) {
    var filterOut, forReport, packages, body;
    return _regenerator()["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            filterOut = function filterOut() {
              var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                  registry = _ref.registry,
                  manifest = _ref["package"],
                  remote = _ref.remote;

              if (flags.pattern && !micromatch.contains(manifest.name, flags.pattern)) {
                return false;
              }

              return true;
            };

            forReport = function forReport() {
              var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                  registry = _ref2.registry,
                  manifest = _ref2["package"],
                  remote = _ref2.remote;

              return [manifest.name, manifest.version, registry, remote && remote.resolved || ''];
            };

            _context4.next = 4;
            return getCachedPackages(config);

          case 4:
            packages = _context4.sent;
            body = packages.filter(filterOut).map(forReport);
            reporter.table(['Name', 'Version', 'Registry', 'Resolved'], body);

          case 7:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _list.apply(this, arguments);
}

function clean(_x8, _x9, _x10, _x11) {
  return _clean.apply(this, arguments);
}

function _clean() {
  _clean = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee5(config, reporter, flags, args) {
    var activity, packages, shouldDelete, packagesToDelete, _iterator4, _step4, manifest, relativePath;

    return _regenerator()["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            if (!config.cacheFolder) {
              _context5.next = 40;
              break;
            }

            activity = reporter.activity();

            if (!(args.length > 0)) {
              _context5.next = 34;
              break;
            }

            _context5.next = 5;
            return getCachedPackages(config);

          case 5:
            packages = _context5.sent;

            shouldDelete = function shouldDelete() {
              var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
                  registry = _ref3.registry,
                  manifest = _ref3["package"],
                  remote = _ref3.remote;

              return args.indexOf(manifest.name) !== -1;
            };

            packagesToDelete = packages.filter(shouldDelete);
            _iterator4 = _createForOfIteratorHelper(packagesToDelete);
            _context5.prev = 9;

            _iterator4.s();

          case 11:
            if ((_step4 = _iterator4.n()).done) {
              _context5.next = 22;
              break;
            }

            manifest = _step4.value;
            relativePath = path.relative(config.cacheFolder, manifest._path);

          case 14:
            if (!(relativePath && relativePath !== '.')) {
              _context5.next = 20;
              break;
            }

            _context5.next = 17;
            return fs().unlink(path.resolve(config.cacheFolder, relativePath));

          case 17:
            relativePath = path.dirname(relativePath);
            _context5.next = 14;
            break;

          case 20:
            _context5.next = 11;
            break;

          case 22:
            _context5.next = 27;
            break;

          case 24:
            _context5.prev = 24;
            _context5.t0 = _context5["catch"](9);

            _iterator4.e(_context5.t0);

          case 27:
            _context5.prev = 27;

            _iterator4.f();

            return _context5.finish(27);

          case 30:
            activity.end();
            reporter.success(reporter.lang('clearedPackageFromCache', args[0]));
            _context5.next = 40;
            break;

          case 34:
            _context5.next = 36;
            return fs().unlink(config._cacheRootFolder);

          case 36:
            _context5.next = 38;
            return fs().mkdirp(config.cacheFolder);

          case 38:
            activity.end();
            reporter.success(reporter.lang('clearedCache'));

          case 40:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[9, 24, 27, 30]]);
  }));
  return _clean.apply(this, arguments);
}

var _buildSubCommands = (0, _buildSubCommands2()["default"])('cache', {
  ls: function ls(config, reporter, flags, args) {
    return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
      return _regenerator()["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              reporter.warn("`yarn cache ls` is deprecated. Please use `yarn cache list`.");
              _context.next = 3;
              return list(config, reporter, flags, args);

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
  },
  list: list,
  clean: clean,
  dir: function dir(config, reporter) {
    reporter.log(config.cacheFolder, {
      force: true
    });
  }
}),
    run = _buildSubCommands.run,
    _setFlags = _buildSubCommands.setFlags,
    examples = _buildSubCommands.examples;

exports.examples = examples;
exports.run = run;

function setFlags(commander) {
  _setFlags(commander);

  commander.description('Yarn cache list will print out every cached package.');
  commander.option('--pattern [pattern]', 'filter cached packages by pattern');
}
//# sourceMappingURL=cache.js.map
