"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasWrapper = hasWrapper;
exports.requireLockfile = void 0;
exports.run = run;
exports.setFlags = setFlags;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _packageRequest() {
  var data = _interopRequireDefault(require("../../package-request.js"));

  _packageRequest = function _packageRequest() {
    return data;
  };

  return data;
}

function _lockfile() {
  var data = _interopRequireDefault(require("../../lockfile"));

  _lockfile = function _lockfile() {
    return data;
  };

  return data;
}

function _install() {
  var data = require("./install.js");

  _install = function _install() {
    return data;
  };

  return data;
}

function _colorForVersions() {
  var data = _interopRequireDefault(require("../../util/color-for-versions"));

  _colorForVersions = function _colorForVersions() {
    return data;
  };

  return data;
}

function _colorizeDiff() {
  var data = _interopRequireDefault(require("../../util/colorize-diff.js"));

  _colorizeDiff = function _colorizeDiff() {
    return data;
  };

  return data;
}

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2()["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var requireLockfile = true;
exports.requireLockfile = requireLockfile;

function setFlags(commander) {
  commander.description('Checks for outdated package dependencies.');
  commander.usage('outdated [packages ...]');
}

function hasWrapper(commander, args) {
  return true;
}

function run(_x, _x2, _x3, _x4) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(config, reporter, flags, args) {
    var lockfile, install, deps, requested, getNameFromHint, colorizeName, usesWorkspaces, body, red, yellow, green, header;
    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _lockfile()["default"].fromDirectory(config.lockfileFolder);

          case 2:
            lockfile = _context.sent;
            install = new (_install().Install)(_objectSpread(_objectSpread({}, flags), {}, {
              includeWorkspaceDeps: true
            }), config, reporter, lockfile);
            _context.next = 6;
            return _packageRequest()["default"].getOutdatedPackages(lockfile, install, config, reporter);

          case 6:
            deps = _context.sent;

            if (args.length) {
              requested = new Set(args);
              deps = deps.filter(function (_ref) {
                var name = _ref.name;
                return requested.has(name);
              });
            }

            getNameFromHint = function getNameFromHint(hint) {
              return hint ? "".concat(hint, "Dependencies") : 'dependencies';
            };

            colorizeName = function colorizeName(_ref2) {
              var current = _ref2.current,
                  latest = _ref2.latest,
                  name = _ref2.name;
              return reporter.format[(0, _colorForVersions()["default"])(current, latest)](name);
            };

            if (!deps.length) {
              _context.next = 21;
              break;
            }

            usesWorkspaces = !!config.workspaceRootFolder;
            body = deps.map(function (info) {
              var row = [colorizeName(info), info.current, (0, _colorizeDiff()["default"])(info.current, info.wanted, reporter), reporter.format.cyan(info.latest), info.workspaceName || '', getNameFromHint(info.hint), reporter.format.cyan(info.url)];

              if (!usesWorkspaces) {
                row.splice(4, 1);
              }

              return row;
            });
            red = reporter.format.red('<red>');
            yellow = reporter.format.yellow('<yellow>');
            green = reporter.format.green('<green>');
            reporter.info(reporter.lang('legendColorsForVersionUpdates', red, yellow, green));
            header = ['Package', 'Current', 'Wanted', 'Latest', 'Workspace', 'Package Type', 'URL'];

            if (!usesWorkspaces) {
              header.splice(4, 1);
            }

            reporter.table(header, body);
            return _context.abrupt("return", 1);

          case 21:
            return _context.abrupt("return", 0);

          case 22:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _run.apply(this, arguments);
}
//# sourceMappingURL=outdated.js.map
