"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };

  return data;
}

function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

  _createClass2 = function _createClass2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _util() {
  var data = require("./util.js");

  _util = function _util() {
    return data;
  };

  return data;
}

var Spinner = /*#__PURE__*/function () {
  function Spinner() {
    var stdout = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.stderr;
    var lineNumber = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    (0, _classCallCheck2()["default"])(this, Spinner);
    (0, _defineProperty2()["default"])(this, "stdout", void 0);
    (0, _defineProperty2()["default"])(this, "prefix", void 0);
    (0, _defineProperty2()["default"])(this, "current", void 0);
    (0, _defineProperty2()["default"])(this, "lineNumber", void 0);
    (0, _defineProperty2()["default"])(this, "delay", void 0);
    (0, _defineProperty2()["default"])(this, "chars", void 0);
    (0, _defineProperty2()["default"])(this, "text", void 0);
    (0, _defineProperty2()["default"])(this, "id", void 0);
    this.current = 0;
    this.prefix = '';
    this.lineNumber = lineNumber;
    this.stdout = stdout;
    this.delay = 60;
    this.chars = Spinner.spinners[28].split('');
    this.text = '';
    this.id = null;
  }

  (0, _createClass2()["default"])(Spinner, [{
    key: "setPrefix",
    value: function setPrefix(prefix) {
      this.prefix = prefix;
    }
  }, {
    key: "setText",
    value: function setText(text) {
      this.text = text;
    }
  }, {
    key: "start",
    value: function start() {
      this.current = 0;
      this.render();
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      if (this.id) {
        clearTimeout(this.id);
      } // build line ensuring we don't wrap to the next line


      var msg = "".concat(this.prefix).concat(this.chars[this.current], " ").concat(this.text);
      var columns = typeof this.stdout.columns === 'number' ? this.stdout.columns : 100;
      msg = msg.slice(0, columns);
      (0, _util().writeOnNthLine)(this.stdout, this.lineNumber, msg);
      this.current = ++this.current % this.chars.length;
      this.id = setTimeout(function () {
        return _this.render();
      }, this.delay);
    }
  }, {
    key: "stop",
    value: function stop() {
      if (this.id) {
        clearTimeout(this.id);
        this.id = null;
      }

      (0, _util().clearNthLine)(this.stdout, this.lineNumber);
    }
  }]);
  return Spinner;
}();

exports["default"] = Spinner;
(0, _defineProperty2()["default"])(Spinner, "spinners", ['|/-\\', '⠂-–—–-', '◐◓◑◒', '◴◷◶◵', '◰◳◲◱', '▖▘▝▗', '■□▪▫', '▌▀▐▄', '▉▊▋▌▍▎▏▎▍▌▋▊▉', '▁▃▄▅▆▇█▇▆▅▄▃', '←↖↑↗→↘↓↙', '┤┘┴└├┌┬┐', '◢◣◤◥', '.oO°Oo.', '.oO@*', '🌍🌎🌏', '◡◡ ⊙⊙ ◠◠', '☱☲☴', '⠋⠙⠹⠸⠼⠴⠦⠧⠇⠏', '⠋⠙⠚⠞⠖⠦⠴⠲⠳⠓', '⠄⠆⠇⠋⠙⠸⠰⠠⠰⠸⠙⠋⠇⠆', '⠋⠙⠚⠒⠂⠂⠒⠲⠴⠦⠖⠒⠐⠐⠒⠓⠋', '⠁⠉⠙⠚⠒⠂⠂⠒⠲⠴⠤⠄⠄⠤⠴⠲⠒⠂⠂⠒⠚⠙⠉⠁', '⠈⠉⠋⠓⠒⠐⠐⠒⠖⠦⠤⠠⠠⠤⠦⠖⠒⠐⠐⠒⠓⠋⠉⠈', '⠁⠁⠉⠙⠚⠒⠂⠂⠒⠲⠴⠤⠄⠄⠤⠠⠠⠤⠦⠖⠒⠐⠐⠒⠓⠋⠉⠈⠈', '⢄⢂⢁⡁⡈⡐⡠', '⢹⢺⢼⣸⣇⡧⡗⡏', '⣾⣽⣻⢿⡿⣟⣯⣷', '⠁⠂⠄⡀⢀⠠⠐⠈']);
//# sourceMappingURL=spinner-progress.js.map
