"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exec = void 0;
exports.forkp = forkp;
exports.forwardSignalToSpawnedProcesses = forwardSignalToSpawnedProcesses;
exports.queue = void 0;
exports.spawn = spawn;
exports.spawnp = spawnp;

function constants() {
  var data = _interopRequireWildcard(require("../constants.js"));

  constants = function constants() {
    return data;
  };

  return data;
}

function _blockingQueue() {
  var data = _interopRequireDefault(require("./blocking-queue.js"));

  _blockingQueue = function _blockingQueue() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function _promise() {
  var data = require("./promise.js");

  _promise = function _promise() {
    return data;
  };

  return data;
}

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var child = require('child_process');

var fs = require('fs');

var path = require('path');

var queue = new (_blockingQueue()["default"])('child', constants().CHILD_CONCURRENCY); // TODO: this uid check is kinda whack

exports.queue = queue;
var uid = 0;
var exec = (0, _promise().promisify)(child.exec);
exports.exec = exec;

function validate(program) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (program.match(/[\\\/]/)) {
    return;
  }

  if (process.platform === 'win32' && process.env.PATHEXT) {
    var cwd = opts.cwd || process.cwd();
    var pathext = process.env.PATHEXT;

    var _iterator = _createForOfIteratorHelper(pathext.split(';')),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var ext = _step.value;
        var candidate = path.join(cwd, "".concat(program).concat(ext));

        if (fs.existsSync(candidate)) {
          throw new Error("Potentially dangerous call to \"".concat(program, "\" in ").concat(cwd));
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
}

function forkp(program, args, opts) {
  validate(program, opts);
  var key = String(++uid);
  return new Promise(function (resolve, reject) {
    var proc = child.fork(program, args, opts);
    spawnedProcesses[key] = proc;
    proc.on('error', function (error) {
      reject(error);
    });
    proc.on('close', function (exitCode) {
      resolve(exitCode);
    });
  });
}

function spawnp(program, args, opts) {
  validate(program, opts);
  var key = String(++uid);
  return new Promise(function (resolve, reject) {
    var proc = child.spawn(program, args, opts);
    spawnedProcesses[key] = proc;
    proc.on('error', function (error) {
      reject(error);
    });
    proc.on('close', function (exitCode) {
      resolve(exitCode);
    });
  });
}

var spawnedProcesses = {};

function forwardSignalToSpawnedProcesses(signal) {
  for (var _i = 0, _Object$keys = Object.keys(spawnedProcesses); _i < _Object$keys.length; _i++) {
    var key = _Object$keys[_i];
    spawnedProcesses[key].kill(signal);
  }
}

function spawn(program, args) {
  var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var onData = arguments.length > 3 ? arguments[3] : undefined;
  var key = opts.cwd || String(++uid);
  return queue.push(key, function () {
    return new Promise(function (resolve, reject) {
      validate(program, opts);
      var proc = child.spawn(program, args, opts);
      spawnedProcesses[key] = proc;
      var processingDone = false;
      var processClosed = false;
      var err = null;
      var stdout = '';
      proc.on('error', function (err) {
        if (err.code === 'ENOENT') {
          reject(new (_errors().ProcessSpawnError)("Couldn't find the binary ".concat(program), err.code, program));
        } else {
          reject(err);
        }
      });

      function updateStdout(chunk) {
        stdout += chunk;

        if (onData) {
          onData(chunk);
        }
      }

      function finish() {
        delete spawnedProcesses[key];

        if (err) {
          reject(err);
        } else {
          resolve(stdout.trim());
        }
      }

      if (typeof opts.process === 'function') {
        opts.process(proc, updateStdout, reject, function () {
          if (processClosed) {
            finish();
          } else {
            processingDone = true;
          }
        });
      } else {
        if (proc.stderr) {
          proc.stderr.on('data', updateStdout);
        }

        if (proc.stdout) {
          proc.stdout.on('data', updateStdout);
        }

        processingDone = true;
      }

      proc.on('close', function (code, signal) {
        if (signal || code >= 1) {
          err = new (_errors().ProcessTermError)(['Command failed.', signal ? "Exit signal: ".concat(signal) : "Exit code: ".concat(code), "Command: ".concat(program), "Arguments: ".concat(args.join(' ')), "Directory: ".concat(opts.cwd || process.cwd()), "Output:\n".concat(stdout.trim())].join('\n'));
          err.EXIT_SIGNAL = signal;
          err.EXIT_CODE = code;
        }

        if (processingDone || err) {
          finish();
        } else {
          processClosed = true;
        }
      });
    });
  });
}
//# sourceMappingURL=child.js.map
