"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LogicalDependencyTree = void 0;

function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };

  return data;
}

function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

  _createClass2 = function _createClass2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _npmLogicalTree() {
  var data = _interopRequireDefault(require("npm-logical-tree"));

  _npmLogicalTree = function _npmLogicalTree() {
    return data;
  };

  return data;
}

var LogicalDependencyTree = /*#__PURE__*/function () {
  function LogicalDependencyTree(packageJson, packageLock) {
    (0, _classCallCheck2()["default"])(this, LogicalDependencyTree);
    (0, _defineProperty2()["default"])(this, "tree", void 0);
    this.tree = (0, _npmLogicalTree()["default"])(JSON.parse(packageJson), JSON.parse(packageLock));
  }

  (0, _createClass2()["default"])(LogicalDependencyTree, [{
    key: "_findNode",
    value: function _findNode(name, parentNames) {
      var parentTree = parentNames ? parentNames.reduce(function (node, ancestor) {
        var ancestorNode = node.dependencies.get(ancestor);
        return ancestorNode;
      }, this.tree) : this.tree;
      var node = parentTree.dependencies.get(name);
      return node;
    }
  }, {
    key: "getFixedVersionPattern",
    value: function getFixedVersionPattern(name, parentNames) {
      var node = this._findNode(name, parentNames);

      var version = node.version;
      return "".concat(node.name, "@").concat(version);
    }
  }]);
  return LogicalDependencyTree;
}();

exports.LogicalDependencyTree = LogicalDependencyTree;
//# sourceMappingURL=logical-dependency-tree.js.map
